
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Test_versionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const test_versions = await db.test_versions.create(
            {
                id: data.id || undefined,
        
        version_label: data.version_label
        ||
        null
            ,
            
        generation_strategy: data.generation_strategy
        ||
        null
            ,
            
        is_locked: data.is_locked
        ||
        false
        
            ,
            
        generated_at: data.generated_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await test_versions.setTest( data.test || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.test_versions.getTableName(),
                belongsToColumn: 'export_pdf',
                belongsToId: test_versions.id,
            },
            data.export_pdf,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.test_versions.getTableName(),
                belongsToColumn: 'export_docx',
                belongsToId: test_versions.id,
            },
            data.export_docx,
            options,
        );
        

        return test_versions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const test_versionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                version_label: item.version_label
            ||
            null
            ,
            
                generation_strategy: item.generation_strategy
            ||
            null
            ,
            
                is_locked: item.is_locked
            ||
            false
        
            ,
            
                generated_at: item.generated_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const test_versions = await db.test_versions.bulkCreate(test_versionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < test_versions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.test_versions.getTableName(),
                    belongsToColumn: 'export_pdf',
                    belongsToId: test_versions[i].id,
                },
                data[i].export_pdf,
                options,
            );
        }
        
        for (let i = 0; i < test_versions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.test_versions.getTableName(),
                    belongsToColumn: 'export_docx',
                    belongsToId: test_versions[i].id,
                },
                data[i].export_docx,
                options,
            );
        }
        

        return test_versions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const test_versions = await db.test_versions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.version_label !== undefined) updatePayload.version_label = data.version_label;
        
        
        if (data.generation_strategy !== undefined) updatePayload.generation_strategy = data.generation_strategy;
        
        
        if (data.is_locked !== undefined) updatePayload.is_locked = data.is_locked;
        
        
        if (data.generated_at !== undefined) updatePayload.generated_at = data.generated_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await test_versions.update(updatePayload, {transaction});

        
        
        if (data.test !== undefined) {
            await test_versions.setTest(
              
              data.test,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.test_versions.getTableName(),
                belongsToColumn: 'export_pdf',
                belongsToId: test_versions.id,
            },
            data.export_pdf,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.test_versions.getTableName(),
                belongsToColumn: 'export_docx',
                belongsToId: test_versions.id,
            },
            data.export_docx,
            options,
        );
        

        return test_versions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const test_versions = await db.test_versions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of test_versions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of test_versions) {
                await record.destroy({transaction});
            }
        });


        return test_versions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const test_versions = await db.test_versions.findByPk(id, options);

        await test_versions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await test_versions.destroy({
            transaction
        });

        return test_versions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const test_versions = await db.test_versions.findOne(
            { where },
            { transaction },
        );

        if (!test_versions) {
            return test_versions;
        }

        const output = test_versions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.version_items_test_version = await test_versions.getVersion_items_test_version({
            transaction
        });
        
        
        output.version_answer_orders_test_version = await test_versions.getVersion_answer_orders_test_version({
            transaction
        });
        
        
        output.exports_test_version = await test_versions.getExports_test_version({
            transaction
        });
        
        
        output.answer_keys_test_version = await test_versions.getAnswer_keys_test_version({
            transaction
        });
        
        
        output.scoring_schemes_test_version = await test_versions.getScoring_schemes_test_version({
            transaction
        });
        
        
        output.test_matrices_test_version = await test_versions.getTest_matrices_test_version({
            transaction
        });
        
        
        
        
        
        
        output.test = await test_versions.getTest({
            transaction
        });
        
        
        output.export_pdf = await test_versions.getExport_pdf({
            transaction
        });
        
        
        output.export_docx = await test_versions.getExport_docx({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tests,
        as: 'test',
        
        where: filter.test ? {
          [Op.or]: [
            { id: { [Op.in]: filter.test.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.test.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'export_pdf',
      },

      {
        model: db.file,
        as: 'export_docx',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.version_label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'test_versions',
                        'version_label',
                        filter.version_label,
                    ),
                };
            }
            

            
            

            
            if (filter.generated_atRange) {
                const [start, end] = filter.generated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.generation_strategy) {
                where = {
                    ...where,
                generation_strategy: filter.generation_strategy,
            };
            }
            
            if (filter.is_locked) {
                where = {
                    ...where,
                is_locked: filter.is_locked,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.test_versions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'test_versions',
                        'version_label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.test_versions.findAll({
            attributes: [ 'id', 'version_label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['version_label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.version_label,
        }));
    }

    
};

